array set print_offset {
        p1 85     p3 26     p4 20
        p5 16     p6 7     p6p 7
        m4 10     m5 7
}

set f_prop Helvetica; set f_fixed Courier
set wish  wish8.0
set netscape  netscape


proc createfont {} {
    catch { font delete p1 p3 p4 p5 p6 p6p m4 m5 }
    global f_prop f_fixed
    font create p1 -family $f_prop -size 256 -weight bold
    font create p3 -family $f_prop -size 64 -weight normal
    font create p4 -family $f_prop -size 48 -weight normal
    font create p5 -family $f_prop -size 32 -weight normal
    font create p6 -family $f_prop -size 24 -weight normal
    font create p6p -family $f_prop -size 24 -weight bold
    font create m4 -family $f_fixed -size 40 -weight normal
    font create m5 -family $f_fixed -size 30 -weight normal
}

proc printpage {} { global w f_prop f_fixed sx sy print_offset 
    bell
    global pgnr current 

    foreach item [$w find withtag text] {
        $w move $item 0 $print_offset([$w itemcget $item -font])
    }

    set a nw; set x 15m; set y 15m
    $w postscript -colormode color -file "print-$current.ps" \
        -height [+ $sy 35] -width [+ 4 $sx] -x -2 -y -2 -rotate 1 \
        -pageanchor $a -pageheight 180m -pagex $x -pagey $y 

    foreach item [$w find withtag text] {
        $w move $item 0 -$print_offset([$w itemcget $item -font])
    }

}

proc initgui {} { global tl w f cmap sx sy cx cy 
    createfont
    set tl .
    set w .c
    wm title . "Tcl/Tk Prsentation"
    wm protocol . WM_DELETE_WINDOW {bell}
    catch {destroy $w}
    set f .f; catch {destroy $f}
    frame $f -relief sunken -bd 2; pack $f -side bottom -fill x -expand yes
    label $f.l -textvariable status -font p6p -relief sunken -bd 1 -padx 5
    pack $f.l -side left -expand yes -fill x
    label $f.pgnr -textvariable pagenumber -font p6p \
        -relief sunken -bd 1 -padx 5
    pack $f.pgnr -side left 
    global linecolor; set linecolor black
    checkbutton $f.draw -text "  /  " -font p6p -variable drawmode -pady -3 \
        -state normal -indicatoron 0 -fg $linecolor -activefore $linecolor\
        -selectcolor [$f cget -bg]
    pack $f.draw -side left -expand no
    set buttonlist {
        pgup {<}  {navi u}
        goto {->}  {navi ask}
        pgdn {>}  {navi d}
    }
    foreach {wn lab cmd} $buttonlist {
        button $f.$wn -text $lab -command $cmd -font p6p -pady -3
        pack $f.$wn -side left -expand no
    }
    
    setstatus "Wait a moment..."
    wm geometry . +300+300
    update 
    setstatus 
    array set cmap [list green #007f00 blue #0000bf red #bf0000]

    if {[winfo exists $w]} { destroy $w }
    set sx [winfo screenwidth .]; set sy [winfo screenheight .]
    incr sy -[winfo height $f]
    set cx [expr {int($sx/2)}]; set cy [expr {int($sy/2)}]
    canvas $w -width $sx -height $sy -bg white -takefocus 1
    $w create rectangle -1 -1 [+ 1 $sx] [+ 2 $sy] -fill {} \
        -outline black -width 2 -tags preserve
    set wm [menu $w.context]
    $wm add command -label "prev page" -underline 0 -command {navi u}
    $wm add command -label "reload page" -underline 0 -command {navi}
    $wm add command -label "next page" -underline 0 -command {navi d}
    $wm add separator
    $wm add command -label "proc & toc" -underline 7 \
        -command {source pres.tcl; scantoc; navi}
    $wm add command -label "reload all" -command {source pres.tcl; init}
    $wm add separator
    $wm add command -label "Icon" -underline 0 -command {wm iconify $tl}
    $wm add command -label "Quit" -underline 0 -command exit
    pack $w
    bind $tl <3> [list tk_popup $wm %X %Y]
    set navilist {
        <Down> d       <space> d        <Up> u
        <Prior> U      <Next> D         <Home> H       <End> E
        <Left> pop     <Right> push
        <r> {}         <g> ask
    }
    foreach z {0 1 2 3 4 5 6 7 8 9} {lappend navilist $z $z}
    foreach {b n} $navilist { bind $tl $b [list navi $n] }

    bind $tl <Key-Escape> [list tk_popup $wm %X %Y]
    bind $tl <Control-Key-r> {source pres.tcl; scantoc; navi}
    bind $tl <Control-Key-R> {source pres.tcl; init}

    bind $tl <Key-p> { printpage }

    bind $w <Double-ButtonPress-1> { 
        if {!$drawmode} continue
        set x [tk_chooseColor -initialcolor $linecolor]
        if {$x != {}} {
            set linecolor $x; $f.draw conf -fg $x -activefore $x
        }
    }
    bind $w <ButtonPress-1> {
        if {!$drawmode} continue
        set %W(line) [
            list %W coords [
                %W create line %x %y %x %y -width 5 -fill $linecolor
            ] %x %y
        ]
        lappend linestack [lindex [set %W(line)] 2]
    }
    bind $w <B1-Motion> {
        if {!$drawmode} continue
        eval [lappend %W(line) %x %y]
    }
    bind $w <ButtonRelease-1> {
        if {!$drawmode} continue
        eval [lappend %W(line) %x %y]
    }
    bind $w <ButtonPress-2> {
        if {![info exists linestack]} return
        %W delete [lindex $linestack end]
        set linestack [lreplace $linestack end end]
    }

    wm geometry $tl +-5+-25
}

proc init {} { global current
    initgui;  # do the initial window-stuff
    scantoc;  # scan page-structure
    set current {}; navi
}

proc scantoc {} { # rescan pages    
    uplevel "#0" {
        catch {unset toc} 
        catch {unset pgnr} 
    }
    global toc pgnr lastpage
    set index 0
    set files [lsort -ascii [glob page_*.*]]
    foreach f $files { incr index
        regexp -- {^page_([0-9]+)\.([0-9]+)$} $f all ch sub
        # if {$sub == 0} { set toc($ch) {}}
        lappend toc($ch) $sub
        set pgnr($ch.$sub) $index 
    }
    set lastpage $index
}

proc navi {{dir {}}} { global toc current
    if {"$dir"=="push"} {push $current; return}
    if {"$dir"=="ask"} {naviask; return}

    set fadeout $current; set old $current
    if {"$current" == ""} { set current 0.0 }

    regexp -- {^([0-9]+)\.([0-9]+)$} $current all ch sub
    switch -exact -- $dir {
        H { # first page
            set current 0.0 
        }
        E { # last page
            set ch [lindex [lsort -integer [array names toc]] end]
            set current $ch.[lindex $toc($ch) end]
        }
        d { # next page
            set i [lsearch -exact $toc($ch) $sub]
            incr i; set n [lindex $toc($ch) $i]
            if {$n == {}} {incr ch; set sub 0} else {set sub $n}
            if {[info exists toc($ch)]} {set current $ch.$sub} else {bell}
        }
        u { # previous page
            set i [lsearch -exact $toc($ch) $sub]
            if {$i > 0} { 
                incr i -1; set current $ch.[lindex $toc($ch) $i]
            } else {
                incr ch -1; 
                if {$ch >= 0} {
                    set current $ch.[lindex $toc($ch) end]
                } else {bell}
            }
        }
        D { # next chapter
            incr ch
            if {[info exists toc($ch)]} {set current $ch.0} else {bell}
        }
        U { # start of this chapter or previous chapter
            if {$sub > 0} { set current $ch.0 
            } else {
                if {$ch > 0} {
                    incr ch -1; set current $ch.0
                } else {bell}
            }
        }
        pop { 
            set new [pop]
            if {[valid $new]} { set current $new } else bell
        }
        {} { set old {}; # just restart page }
        default {
            if {[regexp {^[0-9]+$} $dir]} { set dir "$dir.0"}
            if {[valid $dir]} { set current $dir } else bell
        }
    }
    if {$current != $old} {
        if {$fadeout != {}} {
            if {[catch {cleanup_$fadeout} res] || $res} {cleanup}
        }

        setpagenumber

        source page_$current
        page_$current
        
        global stack w sx sy
        if {"$stack" != {}} {
            button $w.back -text "zurck" -command {navi pop}
            $w create window [* 0.95 $sx] [* 0.05 $sy] -anchor ne -window $w.back
        }
    }
}

proc setpagenumber {} { global pagenumber pgnr lastpage w sx sy current
    set pagenumber "s. $pgnr($current)/$lastpage  ($current)"
    foreach {ch sub} [split $current .] {} 
    if {$ch == 0} {return}
    ptext 0.0 1.00 nw p6p black "Tcl / Tk"
    if {$sub == 0} {set seite "Einleitung"} {set seite "Seite $sub"}
    ptext 0.5 1.00 n  p6p black "Kapitel $ch - $seite"
    ptext 1.0 1.00 ne p6 black "Dipl.-Ing. Andreas Leitgeb"
}

proc crumbout {} { global w sx sy cx cy
    set r [$w create rectangle 1 1 $sx $sy -fill [$w cget -bg]]
    foreach f {gray12 gray25 gray50 gray75} {
        $w itemconf $r -stipple $f
        update idletasks
        after 25
    }
    cleanup
}
proc cleanup {} { global w sx sy  
    $w create rectangle 1 1 $sx $sy -fill [$w cget -bg]
    update idletasks
    $w addtag allbut all
    $w dtag preserve allbut 
    $w delete allbut 
    foreach ww [winfo ch $w] { if {$ww != "$w.context"} {catch {destroy $ww}}}
    update idletasks; 
    uplevel "#0" {catch {unset linestack}}
    return 0 
}

proc naviask {} { global current
    catch {destroy .naviask}
    toplevel .naviask 
    wm title .naviask "Gehe zu ..."
    wm transient .naviask .
    wm geometry .naviask +400+300
    entry .naviask.e -width 10 -font p5; .naviask.e insert 0 $current
    .naviask.e select range 0 end
    bind .naviask.e <Return> {.naviask.ok invoke}
    bind .naviask.e <Escape> {.naviask.cancel invoke}
    focus .naviask.e
    button .naviask.ok -text Ok -font p5\
        -command {navi [.naviask.e get]; destroy .naviask}
    button .naviask.cancel -text Abbrechen -font p5\
        -command {destroy .naviask}
    pack .naviask.e -expand yes -fill x
    pack .naviask.ok .naviask.cancel -side left -fill x
}

proc * {x y} {expr {$x*$y}}
proc + {x y} {expr {$x+$y}}
proc wait {s} {update idletasks; after $s}
proc valid {p} {global pgnr; info exists pgnr($p)}

global stack; if {![info exists stack]} {set stack {}}
proc push {p} { global stack; lappend stack $p }
proc pop {} { global stack
    if {$stack == {}} {return}
    set p [lindex $stack end]
    set stack [lreplace $stack end end] 
    return $p
}
proc mapcolor {c} { global cmap
    if {[info exist cmap($c)]} {set cmap($c)} else {set c}
}

proc ptext {rx ry a f c t args} { global w sx sy 
    set id [
    eval [list $w create text [* $rx $sx] [* $ry $sy] -anchor $a \
        -font $f -fill [mapcolor $c] -text [trim $t]] $args
    ]; $w addtag text withtag $id 
    return $id
}
proc pline {rsx rsy rex rey d c args} { global w sx sy
    eval [list $w create line [* $rsx $sx] [* $rsy $sy] \
        [* $rex $sx] [* $rey $sy] -fill [mapcolor $c] -width $d] $args
}
proc pframe {id {c green} {d 1}} { global w
    set c [mapcolor $c]; set dist 5
    foreach {x y X Y} [$w bbox $id] {}
    incr x -$dist; incr y -$dist; incr X $dist; incr Y $dist
    set fid [
        $w create rectangle $x $y $X $Y -width $d \
            -outline $c;# -fill $c -stipple gray12
    ]
    $w lower $fid $id
    catch {$w addtag $id withtag $fid}
    set id
}
proc pbutton {ry n t cmd {f p5}} { global w sx sy
    button $w.$n -text $t -command $cmd -font $f
    $w create window [* 0.95 $sx] [* $ry $sy] -window $w.$n -anchor ne
}
proc pcode {ry n l t} { global w sx sy current
    set wt $w.${n}_t; set wb $w.${n}_b
    set charw [font measure m4 "**********"]
    if {[catch {set wdth [expr {int(($sx*8.75)/$charw)}]}]} {set wdth 33}
    text $wt -font m4 -fg [mapcolor green] -width $wdth -height $l \
        -bg #e0e0e0 -wrap none
    bindtags $wt [list $wt Text]
    bind $wt <Shift-Key-Escape> [list focus $w]
    bind $wt <Shift-Key-Escape> +break
    bind $wt <Shift-Key-Return> [list $wb invoke]
    bind $wt <Shift-Key-Return> +break
    button $wb -font p5 -text Demo \
        -command [list execwish $wt $n]
    bind $wb <1> [list focus $wb]
    $wt insert end [trim $t]
    set lb [* 0.1 $sx]
    ptext 0.1 $ry nw m4 green $t -tags t$n
    $w move t$n 4 3; pframe t$n
    $w create window $lb [* $ry $sy] \
        -window $wt -anchor nw -tags [list $n]
    set rb [expr {$lb + [winfo reqwidth $wt]}]
    $w create window $rb [* $ry $sy] \
        -window $wb -anchor se -tags [list $n]
    return $wt
} 
proc trim {t} { 
    regsub -all -- "\\\\\\\\\n" $t "\\\\\n" t; 
    regsub -all -- "^ *\n" $t "" t; 
    regsub -all -- "\n *\$" $t "" t; 
    regsub -all -- "(^|\n) *> " $t "\\1" t; 
    set t 
}
proc execwish {wt n} {   global w current f_prop wish
    set filename "demo_${current}_${n}.tcl"
    set code [$wt get 1.0 {end - 1 chars}]
    set fp [open $filename w]
    puts $fp "
        font create p5 -family $f_prop -size 32 -weight normal
        option add \"*Font\" p5
    "
    puts -nonewline $fp $code
    close $fp
    set res [catch {exec $wish $filename -geometry +200+100 &} out]
    if {$res != 0} {bell}
}

proc setstatus {{t {}}} {global status; set status $t}

if {![info exists w]} {init}

